
/**
 * Funciones de troceado para diversos tipos de datos
 */
public class FuncionesTroceado
{
    public static int hashCodeBasico(int i, int max) {
        return i % max;
    }
    
    public static int hashCode(int i, int max, int n) {
        int code=i % max;
        for (int j=1; j<n; j++) {
            i=i/max;
            code=(code+i%max);
        }
        return code % max;
    }
    
    public static int hashCodeMalo(int i, int max, int n) {
        int divisor=max/n; 
        int code=i % divisor;
        for (int j=1; j<n; j++) {
            i=i/divisor;
            code=code+ i%divisor;
        }
        return code;
    }
    
    public static int hashCodeBasico(String s, int max) {
        int clave=0;
        for (int i=0; i<s.length(); i++) {
            clave=(clave*128+ s.charAt(i)) % max;  
        }
        return clave;   
    }
    
    public static int hashCode(String s, int max) {
        int clave=0;
        for (int i=0; i<s.length(); i++) {
            clave=(clave*37+ s.charAt(i));  
        }
        clave = clave % max;
        if (clave<0) {
            clave=clave+max;
        }
        return clave;   
    }
    
}
